﻿
Public Class Form1
    Public Sub New()
        InitializeComponent()
    End Sub
    Private PageSize As Integer = 5
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        DataGridView1.AutoGenerateColumns = False
        DataGridView1.ColumnCount = 3
        DataGridView1.Columns(0).Name = "CustomerID"
        DataGridView1.Columns(0).HeaderText = "Customer Id"
        DataGridView1.Columns(0).DataPropertyName = "CustomerID"
        DataGridView1.Columns(1).HeaderText = "Contact Name"
        DataGridView1.Columns(1).Name = "Name"
        DataGridView1.Columns(1).DataPropertyName = "ContactName"
        DataGridView1.Columns(2).Name = "Country"
        DataGridView1.Columns(2).HeaderText = "Country"
        DataGridView1.Columns(2).DataPropertyName = "Country"
        Me.BindGrid(1)
    End Sub

    Public Sub BindGrid(ByVal startIndex As Integer)
        Using entities As NORTHWINDEntities = New NORTHWINDEntities()
            Dim customers As List(Of Customer) = (From customer In entities.Customers Select customer).OrderBy(Function(customer) customer.CustomerID).Skip((startIndex - 1) * PageSize).Take(PageSize).ToList()
            DataGridView1.DataSource = customers
            Me.PopulatePager(entities.Customers.Count(), startIndex)
        End Using
    End Sub

    Private Sub PopulatePager(ByVal recordCount As Integer, ByVal currentPage As Integer)
        Dim pages As List(Of Page) = New List(Of Page)()
        Dim startIndex, endIndex As Integer
        Dim pagerSpan As Integer = 5
        Dim dblPageCount As Double = CDbl((CDec(recordCount) / Convert.ToDecimal(PageSize)))
        Dim pageCount As Integer = CInt(Math.Ceiling(dblPageCount))
        startIndex = If(currentPage > 1 AndAlso currentPage + pagerSpan - 1 < pagerSpan, currentPage, 1)
        endIndex = If(pageCount > pagerSpan, pagerSpan, pageCount)

        If currentPage > pagerSpan Mod 2 Then

            If currentPage = 2 Then
                endIndex = 5
            Else
                endIndex = currentPage + 2
            End If
        Else
            endIndex = (pagerSpan - currentPage) + 1
        End If

        If endIndex - (pagerSpan - 1) > startIndex Then
            startIndex = endIndex - (pagerSpan - 1)
        End If

        If endIndex > pageCount Then
            endIndex = pageCount
            startIndex = If(((endIndex - pagerSpan) + 1) > 0, (endIndex - pagerSpan) + 1, 1)
        End If

        If currentPage > 1 Then
            pages.Add(New Page With {
                .Text = "First",
                .Value = "1"
            })
        End If

        If currentPage > 1 Then
            pages.Add(New Page With {
                .Text = "<<",
                .Value = (currentPage - 1).ToString()
            })
        End If

        For i As Integer = startIndex To endIndex
            pages.Add(New Page With {
                .Text = i.ToString(),
                .Value = i.ToString(),
                .Selected = i = currentPage
            })
        Next

        If currentPage < pageCount Then
            pages.Add(New Page With {
                .Text = ">>",
                .Value = (currentPage + 1).ToString()
            })
        End If

        If currentPage <> pageCount Then
            pages.Add(New Page With {
                .Text = "Last",
                .Value = pageCount.ToString()
            })
        End If

        pnlPager.Controls.Clear()
        Dim count As Integer = 0

        For Each page As Page In pages
            Dim btnPage As Button = New Button()
            btnPage.Location = New System.Drawing.Point(38 * count, 5)
            btnPage.Size = New System.Drawing.Size(35, 20)
            btnPage.Name = page.Value
            btnPage.Text = page.Text
            btnPage.Enabled = Not page.Selected
            AddHandler btnPage.Click, New System.EventHandler(AddressOf Me.Page_Click)
            pnlPager.Controls.Add(btnPage)
            count += 1
        Next
    End Sub

    Private Sub Page_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim btnPager As Button = (TryCast(sender, Button))
        Me.BindGrid(Integer.Parse(btnPager.Name))
    End Sub

    Public Class Page
        Public Property Text As String
        Public Property Value As String
        Public Property Selected As Boolean
    End Class
End Class